package jp.gr.java_conf.skrb.http;

import java.net.HttpURLConnection;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class RequestParser {
    private static final Pattern HTTPHEAD_PATTERN
	= Pattern.compile("\\A([A-Z]+) +([^ ]+) +HTTP/([0-9\\.]+)$"
			  + ".*^Host: ([^ ]+)$.*\r\n\r\n\\z",
			  Pattern.MULTILINE | Pattern.DOTALL);

    public void parse(CharSequence sequence, ResponseHandler handler) {
        Matcher matcher = HTTPHEAD_PATTERN.matcher(sequence);
        if (matcher.matches() && matcher.group(1).equals("GET")) {
            handler.handle(matcher.group(2));
        } else {
            handler.handleError(HttpURLConnection.HTTP_BAD_REQUEST, "bad request");
        }
    }
}
