package jp.gr.java_conf.skrb.http.nio;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.nio.channels.SelectionKey;
import java.nio.channels.Selector;
import java.nio.channels.ServerSocketChannel;
import java.util.Iterator;

public class NioHTTPServer {
    public final static int THREAD_SIZE = 10;

    private ServerSocketChannel serverChannel;
    private Selector selector;

    public NioHTTPServer(int port, String root) throws IOException {
        // \Pbg`l𐶐Eݒ
        serverChannel = ServerSocketChannel.open();
        serverChannel.socket().setReuseAddress(true);
        serverChannel.socket().bind(new InetSocketAddress(port));

        // mubLO[hɐݒ
        serverChannel.configureBlocking(false);

        // ZN^̐
        selector = Selector.open();

        // \Pbg`lZN^ɓo^
        serverChannel.register(selector, SelectionKey.OP_ACCEPT, new AcceptAction(root));
    }

    public void start() {
        try {
            while(selector.select() > 0) {
                for (Iterator<SelectionKey> it = selector.selectedKeys().iterator(); it.hasNext(); ) {
                    SelectionKey key = it.next();
                    it.remove();
 
                    Action action = (Action)key.attachment();
                    action.execute(key);
                }
            }
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }

    public static void main(String[] args) {
        int port = 8800;
        String root = "root";

        if (args.length == 2) {
            try {
                port = Integer.parseInt(args[0]);
                root = args[1];
            } catch (NumberFormatException ex) {
                // ftHggp
            }
        }

        try {
            NioHTTPServer server = new NioHTTPServer(port, root);
            server.start();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
}
