package jp.gr.java_conf.skrb.http.nio;

import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.channels.SelectionKey;
import java.nio.channels.SocketChannel;
import java.nio.charset.Charset;

import jp.gr.java_conf.skrb.http.RequestParser;

public class RequestAction implements Action {
    private static final Charset ISO_8859_1 = Charset.forName("ISO-8859-1");
    public final static int BUFFER_SIZE = 4096;
    public final static int THREAD_SIZE = 10;

    private static RequestParser parser = new RequestParser();

    private ByteBuffer buffer; 
    private String root;
    private NioResponseHandler handler;

    public RequestAction(String root) {
        buffer = ByteBuffer.allocateDirect(BUFFER_SIZE);
        this.root = root;
    }

    public void execute(SelectionKey key) {
        SocketChannel channel = (SocketChannel)key.channel();
        buffer.clear();

        try {
            while (true) {
                int l = channel.read(buffer);
                if (l < BUFFER_SIZE) {
                    break;
                } else {
                    ByteBuffer tmp = ByteBuffer.allocateDirect(buffer.capacity() + BUFFER_SIZE);
                    buffer.flip();
                    tmp.put(buffer);
                    buffer = tmp;
                }
            }
            
            buffer.flip();

            handler = new NioResponseHandler(channel, root);
            parser.parse(ISO_8859_1.decode(buffer), handler);
        } catch (IOException ex) {
            ex.printStackTrace();
            System.exit(1);
        }
    }
}
