package jp.gr.java_conf.skrb.http.stream;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import jp.gr.java_conf.skrb.http.RequestParser;

public class StreamHTTPServer {
    public final static int THREAD_SIZE = 10;

    private ServerSocket serverSocket;
    private RequestParser parser;
    private ExecutorService service;
    private String root;

    public StreamHTTPServer(int port, String root) throws IOException {
        parser = new RequestParser();
        this.root = root;

        service = Executors.newFixedThreadPool(THREAD_SIZE);

        serverSocket = new ServerSocket();
        serverSocket.setReuseAddress(true);
        serverSocket.bind(new InetSocketAddress(port));
    }

    public void start() {
        Socket socket = null;

        try {
            while(true) {
                socket = serverSocket.accept();
                StreamRequestHandler handler = new StreamRequestHandler(socket, root, parser);
                service.execute(handler);
            }
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }

    public static void main(String[] args) throws IOException {
        int port = 8800;
        String root = "root";

        if (args.length == 2) {
            try {
                port = Integer.parseInt(args[0]);
                root = args[1];
            } catch (NumberFormatException ex) {
                // ftHggp
            }
        }

        StreamHTTPServer server = new StreamHTTPServer(port, root);
        server.start();
    }
}
